(*
Author:  Alexander Krauss <krauss@in.tum.de> (2009, 2010)
Author:  Christian Sternagel <c.sternagel@gmail.com> (2011-2015)
Author:  René Thiemann <rene.thiemann@uibk.ac.at> (2010-2014)
License: LGPL (see file COPYING.LESSER)
*)
theory Sum
imports "../TermFun"
begin

fun hd :: "nat list \<Rightarrow> nat" where
  "hd [] = 0" (* underspecification not supported *)
| "hd (x#xs) = x"

fun null :: "'a list \<Rightarrow> bool" where
  "null [] = True"
| "null _  = False"

function sum :: "nat list \<Rightarrow> nat" where
  "sum xs = (if null xs then 0
                        else hd xs + sum (tl xs))"
  by pat_completeness auto

lemmas tl_simps = list.sel(2-3)

define_trs null.simps
define_trs tl_simps
define_trs hd.simps
define_trs (no_sim) sum.psimps

termination sum
  apply (trs_reduce sum)
  apply expand_trs_problem
  export_termination_problem "sum.xml"
  apply (ceta_import_proof "proofs/sum.proof.xml")
  apply eval
done

end
